#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 300005;

int n, a[MAXN];
set<pair<int, int>> val_npos;
set<pair<int, int>> val_ppos;
set<int> pos;
map<int, vector<int>> idx;

// value and position of the last element and size of the streak
// starting from the minimum element not moved at the front
int v, p, s;

// how many swaps to the back we need to finish the sorting
int calc()
{
    if (make_pair(v, p) < *val_ppos.begin())
    {
        v = (*val_ppos.begin()).first;
        p = (*val_ppos.begin()).second;
        s = 1;
    }

    set<pair<int, int>>::iterator it = --val_ppos.upper_bound(make_pair(v, p));
    v = (*it).first;
    p = (*it).second;
    int last = 0;

    while (it != --val_ppos.end())
    {
        int np1 = (*(++it)).second;
        last = (*it).first;
        it--;
        set<int>::iterator ub = pos.upper_bound(p);
        int np2 = n + 1;
        if (ub != pos.end()) np2 = *ub;

        if (np1 >= np2) it++;
        else break;
        s++;
        v = (*it).first;
        p = np1;
    }

    int extra = 0;
    if (it != --val_ppos.end())
        extra = idx[last].end() - upper_bound(idx[last].begin(), idx[last].end(), p);

    return val_ppos.size() - s - extra;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        val_npos.insert({a[i], -i});
        val_ppos.insert({a[i], +i});
        pos.insert(i);
        if (idx.count(a[i]) == 0) idx[a[i]] = {};
        else idx[a[i]].push_back(i);
    }

    if (n == 1)
    {
        cout << 0 << endl;
        return 0;
    }

    int ans = n, m = 0, t = 1;
    for (int i = 1; i < n; ++ i)
    {
        int to_front = i - 1 - m;
        int to_back = calc();
        ans = min(ans, to_front + to_back);

        pair<int, int> e = *val_npos.begin();
        e.second *= -1;
        val_npos.erase(val_npos.begin());
        val_ppos.erase(val_ppos.find(e));
        pos.erase(pos.find(e.second));

        if (e <= make_pair(v, p)) s--;
        if (e.second == i) m += t;
        else
        {
            m = 0;
            t = 0;
        }
    }

    cout << ans << endl;
    return 0;
}
